#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform float dTime;
layout( location = 1 ) uniform float maxLifeTime;

layout( points ) in;
layout( points ) out;
layout( max_vertices = 50 ) out;

in vec4  gPosition[];
flat in vec4  gVelocity[];
flat in vec2  gScale[];
flat in float gLifetime[];
flat in float gType[];

out vec4  oPosition;
flat out vec4  oVelocity;
flat out vec2  oScale;
flat out float oLifetime;
flat out float oType;


void main()
{
	oPosition = gPosition[0];
	oVelocity = gVelocity[0];
	oLifetime = gLifetime[0];
	oScale = gScale[0];
	oType = gType[0];
	
	float lifeTimeperc = oLifetime / maxLifeTime;
	if( oLifetime < maxLifeTime ){
		
		if( lifeTimeperc > 0.25 && oType == 1.0 ){
			oType += 1.0;	
			for( int i = 0; i < 4; ++i ){
				if( i == 0 ) oPosition += cos(oLifetime + float(i)) * oVelocity;
				if( i == 1 ) oPosition += sin(oLifetime + float(i)) * oVelocity;
				oLifetime = 0.0;
				EmitVertex();
				EndPrimitive();
			}
		}
		
		if( lifeTimeperc > 0.5 && oType == 2.0 ){
			oType += 1.0;	
			for( int i = 0; i < 4; ++i ){
				if( i == 0 ) oPosition += cos(oLifetime + float(i)) * oVelocity;
				if( i == 1 ) oPosition += sin(oLifetime + float(i)) * oVelocity;
				oLifetime = 0.0;
				EmitVertex();
				EndPrimitive();
			}
		}
		
		oPosition = gPosition[0];
		oLifetime = gLifetime[0];
		EmitVertex();
		EndPrimitive();
	}
			
}




