#version 330
#extension GL_ARB_explicit_uniform_location : enable

#define QUADHEIGHT 5.0
#define QUADWIDTH  5.0
#define INSTANCEDEPTH 0.2

layout( location = 0 ) uniform mat4  viewMat;
layout( location = 4 ) uniform mat4  projMat;
//layout( location = 8 ) uniform vec4  centerPoint;
//layout( location = 9 ) uniform vec4  size;
//layout( location = 10 ) uniform sampler2D fogTex;
layout( location = 11 ) uniform sampler2D framebufferDepthTexture;
layout( location = 12 ) uniform vec2 screenResolution;


//layout( points, invocations = 5 ) in; //-> gl_InvocationID;
layout( points ) in; //-> gl_InvocationID;
layout( triangle_strip, max_vertices = 4 ) out;


flat in vec2 gScale[];

out vec2 texCoord;

flat out float particleRadius;
flat out vec4 particleCenterPosition; //particle center in camera space
out		 vec4 billboardPoint; //in cam space


float linstep(float low, float high, float v){
    return clamp((v-low)/(high-low), 0.0, 1.0);
}


void main()
{
	vec4 pos = viewMat * gl_in[0].gl_Position;

	particleCenterPosition = pos;

	//if( gl_InvocationID < 3 ) particleCenterPosition.z -= gl_InvocationID * INSTANCEDEPTH;
	//else if( gl_InvocationID > 3 ) particleCenterPosition.z += (3 - gl_InvocationID) * INSTANCEDEPTH;
	

	float quadw = QUADWIDTH * gScale[0].x;// / gl_InvocationID;
	float quadh = QUADHEIGHT * gScale[0].x;// / gl_InvocationID;

	particleRadius = quadw;

	
	//bottom left:
	gl_Position = pos;
	gl_Position.x -= quadw;
	gl_Position.y -= quadh;
	//if( gl_InvocationID < 3 ) gl_Position.z -= gl_InvocationID * INSTANCEDEPTH;
	//else if( gl_InvocationID > 3 ) gl_Position.z += (3 - gl_InvocationID) * INSTANCEDEPTH;
	billboardPoint = gl_Position;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 0, 0 );
	EmitVertex();
	
	//top left:
	gl_Position = pos;
	gl_Position.x -= quadw;
	gl_Position.y += quadh;
	//if( gl_InvocationID < 3 ) gl_Position.z -= gl_InvocationID * INSTANCEDEPTH;
	//else if( gl_InvocationID > 3 ) gl_Position.z += (3 - gl_InvocationID) * INSTANCEDEPTH;
	billboardPoint = gl_Position;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 0, 1 );
	EmitVertex();
	
	//bottom right:
	gl_Position = pos;
	gl_Position.x += quadw;
	gl_Position.y -= quadh;
	//if( gl_InvocationID < 3 ) gl_Position.z -= gl_InvocationID * INSTANCEDEPTH;
	//else if( gl_InvocationID > 3 ) gl_Position.z += (3 - gl_InvocationID) * INSTANCEDEPTH;
	billboardPoint = gl_Position;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 1, 0 );
	EmitVertex();
	
	//top right:
	gl_Position = pos;
	gl_Position.x += quadw;
	gl_Position.y += quadh;
	//if( gl_InvocationID < 3 ) gl_Position.z -= gl_InvocationID * INSTANCEDEPTH;
	//else if( gl_InvocationID > 3 ) gl_Position.z += (3 - gl_InvocationID) * INSTANCEDEPTH;
	billboardPoint = gl_Position;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 1, 1 );
	EmitVertex();
	
	EndPrimitive();

}