#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform mat4 viewMat;
layout( location = 4 ) uniform mat4 projMat;

flat in vec4 fColor;
in vec2 texCoord;




layout(location = 0, index = 0) out vec4 fragColor;


void main(void)
{
	float rad = dot( texCoord-0.5, texCoord-0.5 );
	if( rad > 0.20 )  discard;
	
	float outside = 1.0 - smoothstep( 0.0, 0.2, rad );
	
	fragColor = vec4( fColor.rgb, outside * 0.85 );
	
	//premultiply alpha
	fragColor.rgb *= fragColor.a;
}

