#version 330
#extension GL_ARB_explicit_uniform_location : enable

#define QUADHEIGHT 0.75

layout( location = 0 ) uniform mat4 viewMat;
layout( location = 4 ) uniform mat4 projMat;

layout( points ) in;
layout( triangle_strip, max_vertices = 4 ) out;

flat in  vec4  gColor[];


out vec2  texCoord;
flat out vec4 fColor;


void main()
{
	fColor = gColor[0];

	
	//bottom left:
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x -= QUADHEIGHT;
	gl_Position.y -= QUADHEIGHT;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 0, 0 );
	EmitVertex();
	
	//top left:
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x -= QUADHEIGHT;
	gl_Position.y += QUADHEIGHT;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 0, 1 );
	EmitVertex();
	
	//bottom right:
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x += QUADHEIGHT;
	gl_Position.y -= QUADHEIGHT;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 1, 0 );
	EmitVertex();
	
	//top right:
	gl_Position = gl_in[0].gl_Position;
	gl_Position.x += QUADHEIGHT;
	gl_Position.y += QUADHEIGHT;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 1, 1 );
	EmitVertex();
	
	EndPrimitive();
}