#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform float dTime;
layout( location = 1 ) uniform float fieldSize;
layout( location = 2 ) uniform vec4  camPos;

layout( points ) in;
layout( points ) out;
layout( max_vertices = 30 ) out; 

in vec4  gPosition[];
flat in vec4  gVelocity[];
flat in vec4  gColor[];

out vec4       oPosition;
flat out vec4  oVelocity;
flat out vec4  oColor;

void main()
{
	oPosition = gPosition[0];
	oPosition += gVelocity[0] * dTime * 0.0000001;
	oVelocity = gVelocity[0];
	oColor = gColor[0];

	float dist =  distance( oPosition, camPos );
	if( dist > fieldSize ){
		oPosition = camPos + normalize(camPos - oPosition) * 0.85 * fieldSize;
		oColor = gColor[0].brga;
	}
	EmitVertex();
	EndPrimitive();
}




