#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform mat4 viewMat;
layout( location = 4 ) uniform mat4 projMat;
layout( location = 8 ) uniform float maxLifeTime;
layout( location = 100 ) uniform float glowmod;


in vec2 texCoord;
flat in vec4  fVelocity;
flat in float fLifetime;

layout(location = 0, index = 0) out vec4 fragColor;



void main(void)
{

	float rad = dot( texCoord-0.5, texCoord-0.5 );
	if( rad > 0.20 )  discard;

	
	float outside = 1.0 - smoothstep( 0.0, 0.2, rad );
	
	fragColor = vec4( 1.0, 1.0, 1.0, outside * 0.75 );
	
	fragColor.a = (1.0 - smoothstep( maxLifeTime * 0.75, maxLifeTime, fLifetime )) * fragColor.a;
	
	fragColor.r -= smoothstep( maxLifeTime * 0.5, maxLifeTime * 1.2, fLifetime );
	fragColor.g -= smoothstep( maxLifeTime * 0.3, maxLifeTime * 6, fLifetime );
	fragColor.b -= smoothstep( maxLifeTime * 0.65, maxLifeTime * 0.9, fLifetime );
	
	fragColor.rgb *= glowmod;
	fragColor.rgb *= fragColor.a;
}

