#version 330
#extension GL_ARB_explicit_uniform_location : enable

#define QUADWIDTH  0.02

layout( points ) in;
layout( triangle_strip, max_vertices = 4 ) out;

layout( location = 0 ) uniform mat4 viewMat;
layout( location = 4 ) uniform mat4 projMat;
layout( location = 8 ) uniform float maxLifeTime;

flat in vec4  gVelocity[];
flat in float gLifetime[];
flat in float gScale[];

out vec2 texCoord;
flat out vec4  fVelocity;
flat out float fLifetime;

void main()
{
	fVelocity = gVelocity[0];
	fLifetime = gLifetime[0];
	float qS = QUADWIDTH;// * gScale[0];
	
	//->eye space
	vec4 pos = viewMat * gl_in[0].gl_Position;
	
	

	//bottom left:
	gl_Position = pos;
	gl_Position.x -= qS;
	gl_Position.y -= qS;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 0, 0 );
	EmitVertex();
	
	//top left:
	gl_Position = pos;
	gl_Position.x -= qS;
	gl_Position.y += qS;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 0, 1 );
	EmitVertex();
	
	//bottom right:
	gl_Position = pos;
	gl_Position.x += qS;
	gl_Position.y -= qS;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 1, 0 );
	EmitVertex();
	
	//top right:
	gl_Position = pos;
	gl_Position.x += qS;
	gl_Position.y += qS;
	gl_Position = projMat * gl_Position;
	texCoord = vec2( 1, 1 );
	EmitVertex();
	
	EndPrimitive();

}