#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform float dTime;
layout( location = 1 ) uniform float maxLifeTime;

layout( points ) in;
layout( points ) out;
layout( max_vertices = 30 ) out;

in vec4  gPosition[];
flat in vec4  gVelocity[];
flat in float gLifetime[];
flat in vec2 gScale[];

out vec4  oPosition;
flat out vec4  oVelocity;
flat out float oLifetime;
flat out vec2 oScale;

void main()
{
	oPosition = gPosition[0];
	oLifetime = gLifetime[0];
	oPosition += gVelocity[0] * dTime * (1.0 - smoothstep(maxLifeTime*0.5, maxLifeTime*0.85, oLifetime) );
	oVelocity = gVelocity[0];
	oScale = gScale[0];
	if( oLifetime < maxLifeTime ){
		EmitVertex();
		EndPrimitive();
	}
}




