#version 330
#extension GL_ARB_explicit_uniform_location : enable

//http://rastergrid.com/blog/2010/09/efficient-gaussian-blur-with-linear-sampling/

layout( location = 0 ) uniform ivec2 pass; //usually 1,0 or 0,1
layout( location = 1 ) uniform ivec2 resolutionWidthHeight;

uniform float offset[3] = float[]( 0.0, 1.3846153846, 3.2307692308 );
uniform float weight[3] = float[]( 0.2270270270, 0.3162162162, 0.0702702703 );


layout( location = 20 ) uniform sampler2D img; //the framebuffer rendered in a texture

noperspective in vec2 fragmentTexCoords;



layout(location = 0 ) out vec4 fragColor;



void main(void)
{
   fragColor = texture( img, vec2( gl_FragCoord ) / vec2( resolutionWidthHeight ) );

   for( int i = 1; i < 3; ++i ){
        //vec2 coff = ( vec2( gl_FragCoord ) + vec2( 0.0, 0.0 ) ) / float(resolutionWidthHeight.x);
        vec2 coff = ( vec2(gl_FragCoord) +  vec2(pass) * offset[i] ) / vec2( resolutionWidthHeight );
        fragColor += texture( img, coff );
        coff = ( vec2(gl_FragCoord) -  vec2(pass) * offset[i] ) / vec2( resolutionWidthHeight );
        fragColor += texture( img, coff );
   }

   fragColor /= 5.0;
}

