#version 330
#extension GL_ARB_explicit_uniform_location : enable


layout( location = 20 ) uniform sampler2D screenTexture;


noperspective in vec2 fragmentTexCoords;
flat in vec2 texelSize;


layout(location = 0 ) out vec4 fragColor;

//USES GPU LINEAR TEXTURE SAMPLING TO DOWNSAMPLE TO 1/4 OF THE ORIGINAL TEXTURE


void main()
{
	fragColor = vec4( 0.0 );
	fragColor += texture( screenTexture, fragmentTexCoords + vec2( -1.0,-1.0 ) * texelSize );
	fragColor += texture( screenTexture, fragmentTexCoords + vec2( -1.0, 1.0 ) * texelSize );
	fragColor += texture( screenTexture, fragmentTexCoords + vec2(  1.0,-1.0 ) * texelSize );
	fragColor += texture( screenTexture, fragmentTexCoords + vec2(  1.0, 1.0 ) * texelSize );
	fragColor /= 4.0;
}