#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform ivec2 pass; //usually 1,0 or 0,1
layout( location = 1 ) uniform ivec2 resolutionWidthHeight;


in vec4 vertex; //vertexposition
in vec2 textureCoords; 

out vec2 fragmentTexCoords;


out vec2 blurTexCoords[16];




void main(void)
{
	fragmentTexCoords = textureCoords;
	gl_Position = vertex;

	vec2 aspect = vec2( resolutionWidthHeight ) / float( resolutionWidthHeight.x );

	blurTexCoords[ 0] = fragmentTexCoords + vec2(pass) * -0.0125 * aspect;
	blurTexCoords[ 1] = fragmentTexCoords + vec2(pass) * -0.0110 * aspect;
	blurTexCoords[ 2] = fragmentTexCoords + vec2(pass) * -0.0095 * aspect;
	blurTexCoords[ 3] = fragmentTexCoords + vec2(pass) * -0.0080 * aspect;
	blurTexCoords[ 4] = fragmentTexCoords + vec2(pass) * -0.0065 * aspect;
	blurTexCoords[ 5] = fragmentTexCoords + vec2(pass) * -0.0050 * aspect;
	blurTexCoords[ 6] = fragmentTexCoords + vec2(pass) * -0.0025 * aspect;
	blurTexCoords[ 7] = fragmentTexCoords + vec2(pass) * -0.0010 * aspect;
	blurTexCoords[ 8] = fragmentTexCoords + vec2(pass) *  0.0010 * aspect;
	blurTexCoords[ 9] = fragmentTexCoords + vec2(pass) *  0.0025 * aspect;
	blurTexCoords[10] = fragmentTexCoords + vec2(pass) *  0.0050 * aspect;
	blurTexCoords[11] = fragmentTexCoords + vec2(pass) *  0.0065 * aspect;
	blurTexCoords[12] = fragmentTexCoords + vec2(pass) *  0.0080 * aspect;
	blurTexCoords[13] = fragmentTexCoords + vec2(pass) *  0.0095 * aspect;
	blurTexCoords[14] = fragmentTexCoords + vec2(pass) *  0.0110 * aspect;
	blurTexCoords[15] = fragmentTexCoords + vec2(pass) *  0.0125 * aspect;

}