#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform mat4	projectionMatrix; //eye space -> homogenous clip space (-> perspective division -> device coords)
layout( location = 4 ) uniform mat4	viewMatrix; //world space -> eye space
layout( location = 7 ) uniform mat4	modelMatrix; 

layout( location = 11) uniform bool	instancingUsed; //-> used in mat4 modelMatrixI instead of the uniform modelMatrix!
in		mat4	modelMatrixInstance;


in vec4 vertex; //vertexposition
in vec4 vertexNormal; //vertexnormals


//outs are then in eye space
out vec4 fragmentNormal;  //normals in eye space
out vec4 fragmentEye;	  //vertex positions in eye space




void main(void)
{
	mat4 modelMatrixUsed = modelMatrix;
	if( instancingUsed == true ) modelMatrixUsed = modelMatrixInstance;
	mat4 modelViewMatrix = viewMatrix * modelMatrixUsed;

	
	fragmentEye = modelViewMatrix * vertex; //just the opposition of the view ray, but not the projection perspective needed

	
	gl_Position = projectionMatrix * fragmentEye; //vertex transformation, right transformation happens first
}
