#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform mat4		projectionMatrix; //eye space -> homogenous clip space (-> perspective division -> device coords)
layout( location = 4 ) uniform mat4		viewMatrix; //world space -> eye space
layout( location = 7 ) uniform mat4		modelMatrix;
layout( location = 11) uniform bool		instancingUsed; //-> used in mat4 modelMatrixI instead of the uniform modelMatrix!
layout( location = 12 ) uniform vec4 	emissiveColor; 
layout( location = 13 ) uniform bool  	useTex;
layout( location = 15) uniform float	modulator;

uniform sampler2D 	emissiveTexture;

layout( location = 14 ) uniform vec2  	textureScaleUV;

//INs:
in vec2 fragmentTexCoords;

//OUT
layout( location = 0 ) out vec4 fragColor;
layout( location = 1 ) out vec4 fragColor1;




void main(void)
{
	fragColor = emissiveColor;
	if( useTex == true ) fragColor = texture( emissiveTexture, fragmentTexCoords * textureScaleUV );
	fragColor.rgb *= modulator;
	fragColor.rgb *= fragColor.a;

	fragColor1 = vec4( gl_FragCoord.z, 1.0, 1.0, fragColor.a );
}

