#version 330
#extension GL_ARB_explicit_uniform_location : enable


layout( location = 0 ) uniform mat4	projectionMatrix; //eye space -> homogenous clip space (-> perspective division -> device coords)
layout( location = 4 ) uniform mat4	viewMatrix; //world space -> eye space
layout( location = 7 ) uniform mat4	modelMatrix;
layout( location = 11) uniform bool	instancingUsed; //-> used in mat4 modelMatrixI instead of the uniform modelMatrix!
layout( location = 12 ) uniform vec4 	emissiveColor; 
layout( location = 13 ) uniform bool  	useTex;


in vec4 vertex; 
in vec2 textureCoords;
in mat4	modelMatrixInstance; 


out vec2 fragmentTexCoords; //glow texture





void main(void)
{
	mat4 modelMatrixUsed = modelMatrix;
	if( instancingUsed == true ) modelMatrixUsed = modelMatrixInstance;

	fragmentTexCoords = textureCoords;
	
	gl_Position = projectionMatrix * viewMatrix * modelMatrixUsed * vertex; 
}
