#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform vec3 lightPosProj;
layout( location = 1 ) uniform int  sampleNumber;
layout( location = 2 ) uniform float lightShaftIntensity;

layout( location = 20 ) uniform sampler2D maskTexture; //the framebuffer rendered in a texture


noperspective in vec2 		fragmentTexCoords;

layout(location = 0 ) out vec4 fragColor;


void main(void)
{	
	//I only use it for god rays, the texture is just a masktexture
	//vec2 dir = lightDir - fragmentTexCoords;
	vec2 dir = lightPosProj.xy - fragmentTexCoords;
	float lightDepth = lightPosProj.z;

	float dist = length( dir );

	dir /= dist; //normalization


	vec4 texvals = texture( maskTexture, fragmentTexCoords );
	float maskval = 1.0 - abs( texvals.g ); //.r == z coodrinate in screen space, save in glow shader
	float objDepth = texvals.r;// * 0.5 + 0.5;

	 
	/*
	//if( maskval == 0.0 ) {
		for( int i = 0; i < sampleNumber; ++i ){
			vec2 texco = fragmentTexCoords + dir * float(i) * dist / float(sampleNumber);
			maskval += 1.0 - texture( maskTexture, texco ).g;
		}
		maskval /= float(sampleNumber);
	//}
	fragColor = vec4( maskval, maskval, maskval, 1.0 );*/


	if( objDepth < lightDepth && objDepth != 0.0 ) fragColor = vec4( 1.0, 0.0, 0.0, 1.0 );
	if( objDepth > lightDepth && objDepth != 0.0 ) fragColor = vec4( 0.0, 1.0, 0.0, 1.0 );
	if( objDepth == 0.0 ) fragColor = vec4( 0.0, 0.0, 1.0, 1.0 );
	
}
