#version 330
#extension GL_ARB_explicit_uniform_location : enable



layout( location = 20 ) uniform sampler2D screenTexture; //the framebuffer rendered in a texture
layout( location = 23 ) uniform sampler2D maskTexture;

layout( location = 3 ) uniform vec3 lightColor;



noperspective in vec2 		fragmentTexCoords;

layout(location = 0 ) out vec4 fragColor;


void main(void)
{	
	vec4 maskval = texture( maskTexture, fragmentTexCoords ); //in r == depth, g = 1.0/0.0 is there is object, 
	vec4 screenval = texture( screenTexture, fragmentTexCoords );

	/*float depth = 1.0 - abs( maskval.r );

	fragColor = vec4( screenval.r * depth, screenval.g * depth, screenval.b * depth, screenval.a );*/

	fragColor = vec4( 0.0 );
	fragColor.rgb = (maskval.rgb * lightColor.rgb) + screenval.rgb;
	fragColor.a = screenval.a;

}
