#version 330
#extension GL_ARB_explicit_uniform_location : enable


//layout( location = 20 ) uniform sampler2D screenTexture; //original picture
layout( location = 21 ) uniform sampler2D downsampledImage;
layout( location = 22 ) uniform sampler2D lensDirtTex;
layout( location = 23 ) uniform sampler2D diffractionStarburst;
layout( location = 5 )  uniform float alpha;

layout( location = 0 ) uniform mat3 diffTransformMat;


noperspective in vec2 		fragmentTexCoords;

layout(location = 0 ) out vec4 fragColor;



void main(void)
{	
	vec3 lensMod = texture( lensDirtTex, fragmentTexCoords ).rgb;

	vec2 lensStarTexCoord = ( diffTransformMat * vec3(fragmentTexCoords, 1.0) ).xy;
	vec3 lensDiff = texture( diffractionStarburst, lensStarTexCoord ).rgb;

	lensMod *= lensDiff;

	vec4 lensFlare = texture( downsampledImage, fragmentTexCoords ) * vec4(lensMod, 1.0);

	fragColor = lensFlare;
	fragColor.a = alpha;

	fragColor.rgb *= fragColor.a;


	//fragColor = texture( screenTexture, fragmentTexCoords ) + lensFlare; //-> since i draw just on the defaultFB
}