#version 330
#extension GL_ARB_explicit_uniform_location : enable


layout( location = 20 ) uniform sampler2D screenTexture; //the framebuffer rendered in a texture

noperspective in vec2 		fragmentTexCoords;

layout(location = 0 ) out vec4 fragColor;



const vec3 lumconvert = vec3( 0.2126, 0.7152, 0.0722 );



void main(void)
{	

	fragColor = vec4( 0.0, 0.0, 0.0, 0.0 );
	vec3 col = texture( screenTexture, fragmentTexCoords ).rgb;
	float lum = col.r * lumconvert.r +  col.g * lumconvert.g +  col.b * lumconvert.b;
	lum += 0.00000001; //since without it is NaN
	//lum = log(lum);
	fragColor.r = lum;
}

