#version 330
#extension GL_ARB_explicit_uniform_location : enable

layout( location = 0 ) uniform mat4	projectionMatrix; //eye space -> homogenous clip space (-> perspective division -> device coords)
layout( location = 4 ) uniform mat4	viewMatrix; //world space -> eye space
layout( location = 7 ) uniform mat4	modelMatrix;
layout( location = 11 ) uniform float ambientLightIntensity;


in vec4 vertex; //vertexposition


//outs are then in eye space
out vec4 fragmentEye;		 //vertex positions in eye space
out vec3 fragmentTexCoords;



void main(void)
{
	mat4 modelViewMatrix = viewMatrix * modelMatrix;

	fragmentEye = modelViewMatrix * vertex; //just the opposition of the view ray, but not the projection perspective needed

	
	fragmentTexCoords = (1.0 - vertex).xyz;
	
	gl_Position = projectionMatrix *  modelViewMatrix * vertex; //vertex transformation, right transformation happens first
}
